import java.util.ArrayList;

/**
 * Klasse fuer Kaffeeautomaten 
 * 
 * @author R.Ortner
 * @version 10.10.2019
 */
public class Kaffeeautomat
{
    /*
     * mehrzeiliger Kommentar, der nicht in den Class Libraries aufscheint
     */
    private int code; // Code zum Entleeren des Automaten
    private int preis; // Preis in Cent 
    private ArrayList<Muenze> eingeworfen; // Muenzen aktuell eingeworfen
    private ArrayList<Muenze> kassa; // alle Muenzen
    private int summe;
    private int zucker;
    private boolean milch;

    /**
     * Konstructor erzeugt leeren Kaffeeautomaten
     */
    public Kaffeeautomat(int preis, int code)
    {
        this.code = code;
        this.preis = preis;
        this.kassa = new ArrayList<>();
        initialisieren();
    }
    
    /**
     * setzt Automaten auf Startwerte zurueck
     */
    public void initialisieren()
    {
        this.eingeworfen = new ArrayList<Muenze>();
        this.zucker =  0;
        this.milch = false;
    }
    
    /**
     * erhoeht die gewuenschte Menge an Zucker um 1
     * gibt aktuell gewaehlte Menge zurueck
     */
    public int mehrZucker()
    {
        this.zucker = this.zucker + 1;
        return this.zucker;
    }

    /**
     * vermindert die gewuenschte Menge an Zucker um 1 
     * gibt aktuell gewaehlte Menge zurueck
     */
    public int wenigerZucker()
    {
        if(this.zucker>0)
        {this.zucker = this.zucker - 1;}
        return this.zucker;
    }
    
    /**
     * wirft Muenze ein
     */
    public void muenzeEinwerfen(Muenze dieMuenze)
    {
        this.eingeworfen.add(dieMuenze);
    }
    
    /**
     * aendert Milchwunsch - gibt aktuelle Einstellung zurueck
     */
    public boolean waehleMilch()
    {
        this.milch = !this.milch; 
        return this.milch;
    }
    
    /**
     * berechnet die Summe aller Muenzen in dieM
     */
    public static int getSumme(ArrayList<Muenze> dieM)
    {
        int summe = 0;
        
        for(Muenze m:dieM)
        {
            summe = summe + m.getWert();
        }
        
        // als for-Schleife
        /*for(int i=0; i<dieM.size();i++)
        {
             summe = summe + dieM.get(i).getWert();
        }*/
        
        return summe;
    }
    
    /**
     * gibt die eingeworfenen Muenzen wieder zurueck
     */
    public ArrayList<Muenze> reset()
    {
        ArrayList<Muenze> rueckgabe = new ArrayList<Muenze>(); 
       
        for(Muenze m:eingeworfen)
            rueckgabe.add(m);
        
        initialisieren();
        return rueckgabe;
    }
    
    /**
     * leert Automaten
     */
    public ArrayList<Muenze> leeren(int code)
    {
        ArrayList<Muenze> rueckg = new ArrayList<>();  
        
        if(this.code==code)
        {
            for(Muenze m:kassa)
               rueckg.add(m);
               
            kassa.clear();   
        }
        
        return rueckg;
    }
    
    
    /**
     * drueckt Taste Kaffee - gibt Kaffee zurueck
     */
    public Kaffee getKaffee()
    {
        if(getSumme(this.eingeworfen)>=this.preis)
        {
            Kaffee k = new Kaffee();
            
            if(this.milch==true)
                k.gibMilchRein();
            
            for(int i=1;i<=this.zucker;i++){    
                k.gibZuckerRein();    
            }
            
            for(Muenze m:eingeworfen)
            {
                kassa.add(m);
            }
            
            initialisieren();
            
            return k;
        }
        
        return null;
    }
}
